# Motion Prediction
This Repository contains models and datasets for motion prediction.

Models
- Simple Encoder-LSTM-Decoder Network (SimpleLSTM)
- Simple TransformerEncoder-MLP Decoder Network (SimpleTransformer)
- Implementation of [VectorNet](https://arxiv.org/pdf/2005.04259v1.pdf) 

Datasets
- [Argoverse](https://www.argoverse.org/av1.html)
- [Argoverse 2](https://www.argoverse.org/av2.html)
- [NuScenes](https://www.nuscenes.org/nuscenes)

## Setup

Create a python 3.8 environment and install dependencies using
```
python setup.py
```

## Data Preparation
### **Argoverse**

Download the Argoverse dataset by following the [Insturctions](https://github.com/argoverse/argoverse-api).

Place files in **_raw\_data_**. Place that folder into the **.data/argoverse** folder.

_Alternative: run script to download data_
```
bash ./scripts/fetch_data_argoverse.sh
```


### **Argoverse 2**

Download the Argoverse 2 dataset by following the [Insturctions](https://github.com/argoverse/av2-api/blob/main/DOWNLOAD.md).

Rename the directory containing **_train_**, **_val_** and **_test_** data to **_raw\_data_**. Place that folder into the **.data/av2** folder.

_Alternative: run script to download data_
```
bash ./scripts/fetch_data_av2.sh
```

### **NuScenes**
Download the NuScenes Map expansion v1.3 as well as the trainval metadata from the [NuScenes Website](https://www.nuscenes.org/nuscenes#download).

Move the contents of the map expansion to the map folder of the trainval map folder and rename the folder **_raw\_data_**. Place that folder into the **.data/nuscenes** folder.

\
_Alternative: run script to download data (Note: Links in the script have to be updated and will probably not work as they only work for a limited amount of time)_
```
bash ./scripts/fetch_data_nuscenes.sh
```

## Preprocessing
Preprocess data by running 

```
python preprocess.py --dataset <name of dataset>
```
``preprocess.py`` allows for the following options to be passed:
- __num_scenarios_train__: number of scenarios processed for training data (default: complete dataset)
- __num_scenarios_val__: number of scenarios processed for val data (default: complete dataset)
- __scenarios_per_file__: number of scenes stored in one processed file (default: 100)

## Train

### Train Model
```
python train.py --dataset <name of dataset> --model <name of model>
```
``train.py`` allows for the following options to be passed:
- __epochs__: number of epochs trained (default see config.yml)
- __batch_size__: batch size used for training (default 64)
- __lr__: learning rate used for training (default see config.yml)
- __weight_decay__: weight decay used for training (default 0 -> not used)
- __seed__: set the default random seed
- __save_path__: set path to where the model should be saved (default is _./models_)
- __loss_function__: set the loss function for training (currently available 'SmoothL1', 'MSE', 'GNLLL')
- __num_predictions__: number of modes K generated by the model
- __input_sec/pred_sec__: length of input and output horizon in seconds
- __data_mini__: train on mini dataset that is part of the reopository
- __reduce_dataset_size__: option to only use fraction of dataset used for training (set in percent)
- __num_workers__: number of workers used by the dataloader
- __log__: if True saves the tensorboard logs of the learning curves in the _./logs/tensorboard_ folder
- __checkpoints__: if True saves checkpoints every epochs to _./logs/checkpoints_ folder
- __train_from_checkpoint__: set to name of checkpoint folder in _./logs/checkpoints_ and checkpoint you want to continue training from e.g. _'folder_name/checkpoint_epoch_x.pth'_
- __finetune__: option to pass model saved in _./trained\_models_ and use that to fine tune model
- __gpu__: just an option to choose the gpu that is used for trainig

### Train using Optuna for hyperparameter search
Searches for optimal weight decay and learning rate for a given model and dataset.
```
python search_hyperparams.py --dataset <name of dataset> --model <name of model>
```
``search_hyperparams.py`` additional parameter:
- __num_trials__: num of trials optuna evlaluates for the hyperparameter search.

_Note:_ 
- *__log__ for tensorboard is not available.*
- *__finetune__ for finetuning pretrained models is not available.*

## Evaluate

Evaluate trained model in _trained\_models_ by running
```
python evaluate.py --trained_model <file name of trained model>
```
``evaluate.py`` allows for the following options to be passed:
- __trained_model__: name of saved model to evaluate 
- __model_path__: path to where the trained_model is saved to 
- __save_eval__: option to save the evaluation results as numpy file 
- __save_path__: path to where evaluation results should be saved to if save_eval is set (default is _./logs/evaluations/_)
- __data_mini__: evaluate on mini dataset that is part of the reopository
- __seed__: set the default random seed
- __reduce_dataset_size__: option to only use fraction of dataset used for training (set in percent)
- __num_workers__: number of workers used by Dataloader
- __batch_size__: batch size used for evaluation (default 128)
- __eval_dataset__: chose dataset on which to evaluate on (deflaut 'val')
- __eval_by_direction__: evaluates left turns, right turns, straight driving and misc scenes separatly (datasets need to be created with filter_scenearios.py)

## Plotting

Plot vector map of scene by running 
```
visualise.py --vector_map True --dataset <name of dataset> --scene_idx <index of scene to plot>
```
*Note: 9 random scenes from the dataset are plotted if scene_idx argument is not passed*

Plot vector map and prediction of scene by running 
```
visualise.py --prediction <name of trained model> --model <model name> --dataset <name of dataset> --scene_idx <index of scene to plot> 
```

Chose dataset (train or val) from wich scene should be plotted by passing __dataset_split__ option (default is 'val').

_Note: Scenes have to be preprocessed before plotting_ 


## Filter Scenarios

Short python script that filters scenenarios of a preprocessed dataset into straight driving, left turn and right turn scenarios and saves them into different folders, that can be used during evaluation.

```
python filter_scenarios.py --dataset <dataset name>
```
``filter_scenarios.py`` allows for the following options to be passed:
- __seed__: set the default random seed
- __data_mini__: evaluate on mini dataset that is part of the reopository
- __scenarios_per_file__: number of scenarios that should be filtered (may not find enough if set to high, default is 100)
- __eval_dataset__: chose dataset to filter (deflaut 'val')
